<template>
  <div class="login_page">
    <div class="login_header">
      <h1 class="login_header_title">{{ title }}</h1>
      <h2 class="login_header_subtitle">{{ subtitle }}</h2>
    </div>
    <div class="login_main">
      <form>
        <div>
          <span>{{ $t('Username') }}</span>
          <primevue-inputtext type="text"
                              autofocus
                              v-model="username"
                              v-bind:class="getClass()"
                              @keyup.enter="login" />
        </div>
        <div>
          <span>{{ $t('Password') }}</span>
          <primevue-inputtext type="password"
                              v-model="password"
                              v-bind:class="getClass()"
                              :feedback="false"
                              autocomplete="on"
                              @keyup.enter="login" />
        </div>
        <div>
          <primevue-button :label="$t('Login')"
                           class="p-button-raised p-button-secondary"
                           :disabled="!validInput"
                           @click.prevent="login"/>
        </div>
      </form>
      <div class="login_main_warning">
        <strong>{{ $t('LoginWarning1') }}</strong>
        <p>{{ $t('LoginWarning2') }}</p>
        <p>{{ $t('LoginWarning3') }}</p>
      </div>
    </div>
    <div class="login_footer">
      <div>
        <span class="login_footer_text">{{ $t('LoginAgreeTerms') }} </span>
        <a class="login_footer_link"
           :href="license_link"
           target="_blank">{{ $t('TaitAgreement') }}</a>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";

import { useStore, ACTIONS } from "@/store";

export default defineComponent({
  data() {
    return {
      username: "",
      password: "",
      incorrectDetails: false,
      license_link: "Tait_General_Software_License_Agreement.pdf"
    };
  },

  created() {
    useStore().dispatch(ACTIONS.SET_HOSTNAME);
  },

  computed: {
    title(): string {
      const store = useStore();
      return store.getters.getTitle;
    },

    subtitle(): string {
      const store = useStore();
      return store.getters.getSubtitle;
    },

    validInput(): string {
      return this.username && this.password;
    }
  },

  methods: {
    login() {
      if (this.validInput) {
        // LOG IN WITH BACKEND THEN:
        this.$router.push({ name: "TestTable" });
      }
    },

    getClass() {
      if (this.incorrectDetails) {
        return "login_main_input p-inputtext-sm p-invalid";
      } else {
        return "login_main_input p-inputtext-sm";
      }
    }
  }
});
</script>

<style scoped>
.login_page
{
  background-color: #414b55;
  background-image: url("../assets/webui_login_background.png");
  background-repeat: no-repeat;
  background-attachment: fixed;
  background-position: center 80px;
  color: #ffffff;
  font-family: Verdana, Arial, Helvetica, sans-serif;
  overflow: hidden;
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
}

.login_header
{
  background-image: url("../assets/webui_logo.png");
  background-repeat: no-repeat;
  background-attachment: fixed;
  background-position: 40px 20px;
  height: 80px;
}

.login_header_title
{
  font-size: 24px;
  font-weight: 100;
  padding-top: 8px;
}

.login_header_subtitle
{
  font-size: 14px;
  font-weight: 100;
}

.login_main
{
  margin-top: 50px;
}

.login_main form span
{
  display: inline-block;
  font-size: 14px;
  margin-bottom: 30px;
  width: 80px;
  position: relative;
  left: -35px;
}

.login_main_input
{
  width: 200px;
  height: 30px;
  position: relative;
  left: -35px;
}

.p-button-secondary
{
  margin: 0 100px 0 80px;
  height: 30px;
  width: auto;
  min-width: 100px;
  position: relative;
  left: 10px;
  background-color: #636c77;
}

.login_main_warning
{
  margin: 72px auto;
  width: 40%;
}

.login_footer
{
  position: fixed;
  text-align: center;
  left: 0;
  right: 0;
  bottom: 12px;
}

.login_footer_text, .login_footer_link, .login_footer_link:visited
{
  color: #ffffff;
  font-size: 12px;
}
</style>
